Index: WAeUP_SRP/trunk/skins/waeup_student/study_course_view.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/study_course_view.pt	(revision 8329)
+++ WAeUP_SRP/trunk/skins/waeup_student/study_course_view.pt	(revision 8391)
@@ -8,5 +8,5 @@
     <span tal:define="create_level info/create_level|nothing;
                       is_so info/is_so;
-                      titles here/getStudentObjectTitles;">               
+                      titles here/getStudentObjectTitles;">
     <a href=""
        tal:attributes="href string:${here/academicsParent}">
@@ -14,5 +14,5 @@
       Up one level
     </a>
-    <h3> 
+    <h3>
        <span tal:condition="python:is_so and info">
          <span tal:content="info/student/name" />:
@@ -20,25 +20,25 @@
        <span tal:condition="info/is_student">
           My
-       </span>       
+       </span>
        <span tal:content="titles/StudentStudyCourse" />
     </h3>
-    <br />  
+    <br />
     <table tal:define="sc python: info['course_doc']">
       <tr>
-        <td width="220px">Current Session:</td> 
+        <td width="220px">Current Session:</td>
         <td><span tal:content="python:context.portal_vocabularies.sessions.get(info['doc'].current_session)" /></td>
       </tr>
       <tr>
-        <td width="220px">Current Study Level:</td> 
+        <td width="220px">Current Study Level:</td>
         <td><span tal:content="python:context.portal_vocabularies.student_levels.get(info['doc'].current_level)" /></td>
       </tr>
       <tr>
-        <td width="220px">Current Verdict:</td> 
+        <td width="220px">Current Verdict:</td>
         <td><span tal:content="info/verdict" /></td>
       </tr>
       <tr>
-        <td width="220px">Previous Verdict:</td> 
+        <td width="220px">Previous Verdict:</td>
         <td><span tal:content="info/previous_verdict" /></td>
-      </tr>      
+      </tr>
       <span tal:define="f_id sc/faculty;
         d_id sc/department;
@@ -49,5 +49,5 @@
         >
       <tr>
-        <td width="220px">Certificate:</td> 
+        <td width="220px">Certificate:</td>
         <td tal:content="c_title" />
       </tr>
@@ -61,10 +61,10 @@
           </tr>
           <tr>
-            <td>Department:</td> 
+            <td>Department:</td>
             <td><span tal:content="d_title" /></td>
           </tr>
         </span>
-      </table>        
-    
+      </table>
+
     <form action="" method="post" class="group" onsubmit="return submit_once()"
           tal:attributes="action info/action"
@@ -72,9 +72,9 @@
           >
       <span tal:condition="rows">
-      
-      <table  class="contentListing" width="100%" summary="content layout" id="folder_content">      
+
+      <table  class="contentListing" width="100%" summary="content layout" id="folder_content">
         <tr tal:repeat="row rows"
           tal:attributes="class python:test(repeat['row'].even(), 'even ajaxtd', 'odd ajaxtd')">
-          <td align="left" valign="middle" style="width: 5px;" 
+          <td align="left" valign="middle" style="width: 5px;"
               tal:condition="python:is_so">
             <input type="checkbox" name="ids:list" value="" id="" class="noborder"
@@ -83,10 +83,10 @@
                    tal:attributes="value id;
                    id python:'cb_' + id;
-                   checked python:id in info['choosen_ids'];" 
+                   checked python:id in info['choosen_ids'];"
                    />
           </td>
           <td><a href="view"
                  tal:attributes="href string:${row/url}">
-            <strong tal:content="row/title" /></a> 
+            <strong tal:content="row/title" /></a>
           </td>
         </tr>
@@ -108,5 +108,5 @@
                    class="destructive" i18n:attributes="value"
                    tal:attributes="onclick python:'return window.confirm(\'%s\')' %
-                   (cpsmcat('description_confirm_delete'), )" 
+                   (cpsmcat('description_confirm_delete'), )"
                    />
           </td>
@@ -125,13 +125,13 @@
           <td align="left" valign="top" rowspan="3"></td>
           <td align="left" valign="top">
-            <input type="submit" name="create_level" 
-                     class="destructive" 
-                     tal:attributes="value string: Register Courses for ${info/create_level_str}" 
+            <input type="submit" name="create_level"
+                     class="destructive"
+                     tal:attributes="value string: Register Courses for ${info/create_level_str}"
                      />
           </td>
         </tr>
       </table>
-    </form>  
-    
+    </form>
+
     <div tal:condition="info/missing_data">
        <font color='red'>
Index: WAeUP_SRP/trunk/skins/waeup_uniben/getPaymentsFolderInfo.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_uniben/getPaymentsFolderInfo.py	(revision 8329)
+++ WAeUP_SRP/trunk/skins/waeup_uniben/getPaymentsFolderInfo.py	(revision 8391)
@@ -123,5 +123,5 @@
     row['is_requeryable_interswitch'] = "%s_%s" % (payment.category,payment.session_id) not in paid_fees and payment.type == 'online' #or str(member) in ('admin',)
     row['is_requeryable_etranzact'] = "%s_%s" % (payment.category,payment.session_id) not in paid_fees and payment.type == 'etranzact' #or str(member) in ('admin',)
-    row['is_approvable'] = is_so and (row['is_requeryable_interswitch'] or row['is_requeryable_etranzact'])and payment.category == 'schoolfee' # does not make sense for maitenance
+    row['is_approvable'] = is_so and (row['is_requeryable_interswitch'] or row['is_requeryable_etranzact'])
     row['resp_desc'] = payment.resp_desc or 'Payment Process Interrupted'
     row['trans_ref'] = payment.order_id