Index: /main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py	(revision 8428)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/payments/interfaces.py	(revision 8429)
@@ -131,4 +131,11 @@
         )
 
+    r_desc = schema.TextLine(
+        title = _(u'Response Description'),
+        default = None,
+        required = False,
+        readonly = False,
+        )
+
     def approve():
         "Approve an online payment and set to paid."
Index: /main/waeup.kofa/trunk/src/waeup/kofa/payments/payment.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/payments/payment.py	(revision 8428)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/payments/payment.py	(revision 8429)
@@ -23,4 +23,5 @@
 from grok import index
 from zope.component import getUtility
+from zope.i18n import translate
 from waeup.kofa.interfaces import IKofaUtils
 from waeup.kofa.interfaces import MessageFactory as _
@@ -81,5 +82,9 @@
         self.r_code = u'AP'
         self.p_state = 'paid'
-        #user = get_current_principal()
+        user = get_current_principal()
+        r_desc = _('Payment approved by ${a}', mapping = {'a': user.id})
+        portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
+        self.r_desc = translate(r_desc, 'waeup.kofa',
+            target_language=portal_language)
         self.payment_date = datetime.utcnow()
         return
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 8428)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 8429)
@@ -1399,4 +1399,5 @@
         self.assertEqual(payment.r_amount_approved, 3456.0)
         self.assertEqual(payment.r_code, 'AP')
+        self.assertEqual(payment.r_desc, u'Payment approved by K1000000')
         # The new CLR-0 pin has been created
         self.assertEqual(len(self.app['accesscodes']['CLR-0']),1)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 8428)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 8429)
@@ -370,7 +370,7 @@
             'ac,amount_auth,creation_date,matric_number,p_category,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
-            'r_code,reg_number\r\n'
-
-            ',0.0,2012-04-01 13:12:01,,schoolfee,,,,,unpaid,,0.0,,\r\n'
+            'r_code,r_desc,reg_number\r\n'
+
+            ',0.0,2012-04-01 13:12:01,,schoolfee,,,,,unpaid,,0.0,,,\r\n'
             )
         return
@@ -388,9 +388,9 @@
             'ac,amount_auth,creation_date,matric_number,p_category,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
-            'r_code,reg_number\r\n'
+            'r_code,r_desc,reg_number\r\n'
 
             '666,0.0,2012-04-01 13:12:01,M123456,schoolfee,my-id,'
             'p-item,100,2012,unpaid,2012-04-01 14:12:01,12.12,'
-            'r-code,123456\r\n'
+            'r-code,,123456\r\n'
             )
         return
@@ -407,9 +407,9 @@
             'ac,amount_auth,creation_date,matric_number,p_category,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
-            'r_code,reg_number\r\n'
+            'r_code,r_desc,reg_number\r\n'
 
             '666,0.0,2012-04-01 13:12:01,M123456,schoolfee,my-id,'
             'p-item,100,2012,unpaid,2012-04-01 14:12:01,12.12,'
-            'r-code,123456\r\n'
+            'r-code,,123456\r\n'
             )
         return
@@ -426,9 +426,9 @@
             'ac,amount_auth,creation_date,matric_number,p_category,p_id,'
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
-            'r_code,reg_number\r\n'
+            'r_code,r_desc,reg_number\r\n'
 
             '666,0.0,2012-04-01 13:12:01,M123456,schoolfee,my-id,'
             'p-item,100,2012,unpaid,2012-04-01 14:12:01,12.12,'
-            'r-code,123456\r\n'
-            )
-        return
+            'r-code,,123456\r\n'
+            )
+        return